SystemOrganization addCategory: #UMLDiagramsTools!

SHWorkspace subclass: #DiagramWorkspace
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramsTools'!

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 02:56'!
acceptContents: aText from: anEditor
	self model clearRelationshipsOfSelectedDescription.
	anEditor selectAll;  doIt.
	self model acceptContents: aText .
	self acceptContents: aText.! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 17:13'!
bindingOf: aString
	^self model bindingOf: aString! !

!DiagramWorkspace methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 17:41'!
descriptionCode
	^self model descriptionCode ! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/4/2010 02:49'!
doItReceiver 
	^model model! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 17:12'!
hasBindingOf: aString
	^self model hasBindingOf: aString! !

!DiagramWorkspace methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 17:10'!
model
	^ model! !

!DiagramWorkspace methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 17:44'!
model: anObject
	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject.
	model initializeBindings.! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 02:02'!
update: aParameter
	(aParameter == #descriptionCode)
		ifTrue:[self acceptContents: model selectedDescriptionCode].
	self changed: aParameter! !

Morph subclass: #DiagramWhiteboard
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramsTools'!

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 00:17'!
model: anObject
	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject.
	self update: #view! !

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 05:53'!
update: aParameter
	(aParameter == #view) 
		ifTrue:[self removeAllMorphs. model update. self addAllMorphs: model diagramElements]! !

SystemWindow subclass: #UMLDiagramWindow
	instanceVariableNames: 'diagram'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramsTools'!

!UMLDiagramWindow class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/1/2010 16:42'!
on: aModel
	^(self new model: aModel) createView ! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/31/2010 19:53'!
acceptContents: contents 
	self model: (Compiler evaluate: contents)! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 04:48'!
createView 
	| diagramCode |
	diagramCode  := (PluggableShoutEditorMorph 
		on: (DiagramWorkspace new model: model selectedDiagramModel) 
		text: #descriptionCode 
		accept: #acceptContents:from:
		readSelection: nil 
		menu: #codePaneMenu:shifted:).

diagram := DiagramWhiteboard new.
diagram clipSubmorphs: true.
diagram model: model selectedDiagramModel.
self addMorph: diagram frame: (0@0 corner: 1@0.8).
self addMorph: self diagramsList frame: (0@0.8 corner: 0.25@1).
self addMorph: self descriptionsList frame: (0.25@0.8 corner: 0.5@1).
self addMorph: diagramCode frame: (0.5@0.8 corner: 1@1).
! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/31/2010 19:57'!
descriptionCode 
	^model ifNil: [''] ifNotNil: [model descriptionCode] ! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/2/2010 00:10'!
descriptionsList
	^PluggableListMorph new
		on: self model selectedDiagramModel
		list: #list
		selected: #selectedIndex
		changeSelected: #selectedIndex:
		menu: #listMenu:shifted:
		keystroke: #listKey:from:;
		 borderWidth: 0;
		 enableDragNDrop: false;
		 autoDeselect: true;
		 yourself! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/1/2010 23:44'!
diagramsList
	^PluggableListMorph new
		on: self model
		list: #list
		selected: #selectedIndex
		changeSelected: #selectedIndex:
		menu: #listMenu:shifted:
		keystroke: #listKey:from:;
		 borderWidth: 0;
		 enableDragNDrop: false;
		 autoDeselect: true;
		 yourself! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/1/2010 16:46'!
model: aModel
	super model: aModel.
	self setLabel: model diagramName.

! !

!UMLDiagramWindow methodsFor: 'accessing' stamp: 'carlaGriggio 8/2/2010 00:38'!
selectedDescriptionModel
	^self model selectedDiagramModel ! !

PluggableShoutMorph subclass: #PluggableShoutEditorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramsTools'!

!PluggableShoutEditorMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 03:03'!
selectAll
	super selectAll.
	selectionInterval := self textMorph editor selectionInterval.! !

!PluggableShoutEditorMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 03:01'!
selectFrom: start to: stop
	super selectFrom: start to: stop.
	selectionInterval := self textMorph editor selectionInterval.! !

Object subclass: #NullDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramsTools'!

!NullDescription methodsFor: 'accessing' stamp: 'carlaGriggio 8/6/2010 03:47'!
descriptionCodeWithoutCreation
	^String empty ! !

Object subclass: #NullDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramsTools'!

!NullDiagram methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:08'!
classBoxes
	^#()! !

!NullDiagram methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:09'!
classBoxesDescriptions
	^#()! !

!NullDiagram methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:12'!
classBoxesMorphs
	^#()! !

!NullDiagram methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:12'!
descriptionCodeOf: aClassDescription
	^String empty! !

Object subclass: #UMLToolModel
	instanceVariableNames: 'model selectedIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramsTools'!

UMLToolModel subclass: #DiagramModel
	instanceVariableNames: 'bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramsTools'!

!DiagramModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 21:48'!
acceptContents: aText 
	self bindingOfSelectedDescription updateRealClassBox.
	self changed: #list.
	self changed: #descriptionCode.
	self changed: #view.
	self changed.! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 21:39'!
bindingOf: aString
	^bindings associationAt: aString ifAbsent:[self error:'No class description associated with the variable: ', aString ].

	! !

!DiagramModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 21:48'!
bindingOfSelectedDescription
	^(self bindingOf: self selectedDescription classNameForDescriptionVariable) value! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 15:46'!
changed
	self initializeBindings.
	self changed: #list.
	self changed: #view.
	self changed: #descriptionCode.
	super changed.! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/4/2010 02:01'!
changed: aParameter
	(aParameter == #selectedIndex)
		ifTrue:[
			self changed: #descriptionCode.
			self changed: #view].
	super changed: aParameter ! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 15:43'!
chooseClassFromCategory
	| dialog choice |
	dialog := PopupChoiceOrRequestDialogWindow new filterInput: false;
		title: 'Choose a class from the category ', self category;
		labels: (SystemOrganization classesInCategory: self category);
		lines: #();
		model: (SystemOrganization classesInCategory: self category).
	choice := (SystemWindow topWindow openModal: dialog) choice.
	dialog cancelled ifTrue: [ ^nil ].
	choice 
		ifNotNil: [ ^choice ]
		ifNil: [ ^dialog filterValue ]! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 02:28'!
clearRelationshipsOfSelectedDescription 
	self bindingOfSelectedDescription clearRelationships ! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 15:46'!
createClassBox
	| className |
	className := self request: 'Class Name' default: ''.
	self model addNewClassDescriptionNamed: className.
	self changed.! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 15:51'!
createClassBoxFromCategoryClass
	self createClassBoxFromClass: self chooseClassFromCategory.
	self changed.! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 15:54'!
createClassBoxFromClass
	|className|
	className := self request: 'From which class would you like to create a new Class Box?' default: nil.
	self createClassBoxFromClass: (Smalltalk at: className asSymbol ).
	self changed.! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 15:53'!
createClassBoxFromClass: aClass
	 self model addClassDescription: (ClassBox fromClass: aClass )! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 03:50'!
deleteClassBox
	self model removeClassDescription: self selectedDescription .
	self selectedIndex: self selectedIndex -1.
	self changed: #list.
	self changed: #view.
	self changed: #descriptionCode.
	self initializeBindings.
! !

!DiagramModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:16'!
descriptionCode
	^self model descriptionCodeOf: self selectedDescription ! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 02:04'!
diagramElements 
	^self model classBoxesMorphs! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 17:13'!
hasBindingOf: aString
	^(bindings notNil and: [bindings includesKey: aString])! !

!DiagramModel methodsFor: 'binding' stamp: 'carlaGriggio 8/5/2010 21:39'!
initializeBindings
	bindings := Dictionary new.
	self model classBoxes keys do:[:de |
		bindings at: de classNameForDescriptionVariable put:  (ClassBoxUpdater new realClassBox: de)]! !

!DiagramModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:08'!
list
	^self model ifNotNil:[self model classBoxesDescriptions]
	 "This should be changed when integrating other kinds of diagrams, doing a double dispatch maybe"
	ifNil:[#()]! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 15:45'!
listMenu: aMenu shifted: shifted
	self list ifNotEmpty:[
		aMenu addList: #(('Delete class box'	deleteClassBox) ('Rename class box'	renameClassBox));
			addLine].
		aMenu 
			addList: #(
					('Add new class box' 		createClassBox) 
					('Add new class box from existing class in category' createClassBoxFromCategoryClass)
					('Add new class box from existing class' createClassBoxFromClass)).
	^ aMenu ! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 04:03'!
model: aModel
	super model: aModel.
	self initializeBindings.
	self selectedIndex: 1.
	! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/2/2010 01:41'!
replaceCurrentDescriptionWith: aClassBox 
	self model replace: self selectedDescription with: aClassBox! !

!DiagramModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/6/2010 03:47'!
selectedDescription
	^self list at: self selectedIndex ifAbsent:[NullDescription new]! !

!DiagramModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:11'!
selectedDescriptionCode
	^self model descriptionCodeOf: self selectedDescription! !

!DiagramModel methodsFor: 'updating' stamp: 'carlaGriggio 8/6/2010 02:02'!
update
	model update.! !

UMLToolModel subclass: #DiagramsModel
	instanceVariableNames: 'selectedDiagramModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UMLDiagramsTools'!

!DiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 00:46'!
changed
	self selectedDiagramModel model: self selectedDiagram.
	super changed.! !

!DiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:13'!
changed: aParameter
	(aParameter == #selectedIndex)
		ifTrue:[
			self selectedDiagramModel model: self selectedDiagram.
			self selectedDiagramModel changed: #list.
			self selectedDiagramModel changed: #descriptionCode.
			self selectedDiagramModel changed: #view.
			self changed: #relabel].
	super changed: aParameter ! !

!DiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 04:01'!
createDiagram
	|diagramName|
	diagramName := self request: 'Diagram Name' default: ''.
	self model addDiagram: (UMLClassDiagram new name: diagramName).
	self changed: #list! !

!DiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 02:14'!
deleteDiagram
	self model removeDiagram: self selectedDiagram .
	self changed: #list.
	self changed: #selectedIndex.
	"self selectedIndex: self selectedIndex -1."
	

! !

!DiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/6/2010 16:52'!
labelString
	^self model category, ' - ', self selectedDiagram name! !

!DiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/1/2010 17:08'!
list
	^self model diagrams! !

!DiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 15:37'!
listMenu: aMenu shifted: aBoolean
	aMenu addList: #(
		('delete diagram'	deleteDiagram)
		('add new diagram'	createDiagram)).
	^ aMenu! !

!DiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 02:07'!
selectedDiagram
	^ self list at: self selectedIndex ifAbsent:[NullDiagram new]! !

!DiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 00:46'!
selectedDiagramModel
	^selectedDiagramModel ifNil:[selectedDiagramModel := DiagramModel new model: self selectedDiagram .]! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 15:41'!
category
	^self model category! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 00:46'!
diagramName 
	^self selectedDiagram name! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 01:34'!
initialize 
	selectedIndex := 1.! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 00:46'!
list
	self subclassResponsibility! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 00:46'!
model
	^ model! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 17:21'!
model: anObject
	model := anObject.! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 03:11'!
request: aTitle default: aDefaultValue
	^UIManager default
		request: aTitle
		initialAnswer: aDefaultValue! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 00:46'!
selectedIndex
	^ selectedIndex! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 00:46'!
selectedIndex: anIndex
	anIndex > 0
		ifTrue: [ 
			selectedIndex := anIndex.
			self changed: #selectedIndex.
			]! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 00:46'!
update: anObject 
	super update: anObject.
	self changed: #list! !
